<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2006 Daniel Schledermann (daniel@typoconsult.dk)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module 'Directmail' for the 'tcdirectmail' extension.
 *
 * @author	Daniel Schledermann <daniel@typoconsult.dk>
 */





	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);	
require_once ('../class.tx_tcdirectmail_tools.php');
require_once ('../class.tx_tcdirectmail_mailer.php');
require_once ("conf.php");
require_once ($BACK_PATH."init.php");
require_once ($BACK_PATH."template.php");
require_once (PATH_typo3conf.'/localconf.php');
$LANG->includeLLFile("EXT:tcdirectmail/mod1/locallang.xml");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]
	
$ICON_PATH = $BACK_PATH.'gfx/';	

class tx_tcdirectmail_module1 extends t3lib_SCbase {
	var $pageinfo;

	/**
	 * 
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		
		parent::init();

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
		$TYPO3_DB = $GLOBALS['TYPO3_DB'];
		
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 */
	function menuConfig()	{
		global $LANG, $MODULE_PARTS;
		
		$this->MOD_MENU = Array (
			"function" => Array (
				"status" => $LANG->getLL("status"),
				'maintanence' => $LANG->getLL('maintenance'),
				'validity' => $LANG->getLL('validity'),
			)
		);
		
		parent::menuConfig();
		
	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		
		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{
	
				// Draw the header.
			$this->doc = t3lib_div::makeInstance("bigDoc");
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form='<form action="" method="POST">';

				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				</script>
			';

			$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
			$this->content.=$this->doc->divider(5);

			
			// Render content:
			$this->moduleContent();

			
			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
			}
		
			$this->content.=$this->doc->spacer(10);
		} else {
				// If no access or if ID == zero
		
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
		
			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	}

	/**
	 * Prints out the module HTML
	 */
	function printContent()	{

		$this->content.=$this->doc->endPage();
		echo $this->content;
	}
	
	/**
	 * Generates the module content
	 */
	function moduleContent()	{
		global $LANG, $TYPO3_DB;
		
		/* Must have an id */
		if (!$_REQUEST['id']) return;

		/* Must be a directmail page */
		$rs = $TYPO3_DB->sql_query('SELECT doktype FROM pages WHERE uid = '.intval($_REQUEST['id']));
		list($doktype) = $TYPO3_DB->sql_fetch_row($rs);

		if ($doktype != 189) {
		    $content = $this->notADirectmailPage();
		    $this->content.=$this->doc->section($LANG->getLL("error"),$content,0,1);
		    return;
		}

		switch((string)$this->MOD_SETTINGS["function"])	{

			case 'status':
				$content = $this->viewStatus();
				$this->content.=$this->doc->section($LANG->getLL("status"),$content,0,1);
			break;
			
			case 'maintanence':
				$content = $this->doMaintenance();
				$this->content.=$this->doc->section($LANG->getLL("maintenance"),$content,0,1);
			break;
			
			
			case 'validity':
				$content = $this->checkMailValidity();
				$this->content.=$this->doc->section($LANG->getLL("validity"),$content,0,1);
			break;
			
			default :
				$obj = t3lib_div::makeInstance((string)$this->MOD_SETTINGS["function"]);
				$this->content.=$obj->main();
			break;
			
		} 
	}
	
	/* View current mail delevery, if any */
	function viewStatus() {
	    global $TYPO3_DB;	
	    global $LANG;
	    global $ICON_PATH;


	    /* Schedule a send? */
	    if ($_REQUEST['send_now']) {
		$TYPO3_DB->sql_query("UPDATE pages SET tx_tcdirectmail_senttime = ".time()." WHERE uid = $_REQUEST[id]");
	    }
	    
	    /* Send a test mail */
	    if ($_REQUEST['send_test']) {
		$rs = $TYPO3_DB->exec_SELECTquery('*', 'pages', "uid = $_REQUEST[id]");
	    
		tx_tcdirectmail_tools::mailForTest($TYPO3_DB->sql_fetch_assoc($rs), $_REQUEST['test_send_receivers']);
	    }
	    

	    /* Get page info */
	    $rs = $TYPO3_DB->exec_SELECTquery('doktype, tx_tcdirectmail_real_target, tx_tcdirectmail_test_target, tx_tcdirectmail_senttime, tx_tcdirectmail_dotestsend', 'pages', "uid = $_REQUEST[id]");
	    list ($doktype, $targetUids, $testUid, $sendtime, $do_testsend) = $TYPO3_DB->sql_fetch_row($rs);



	    /* Check if there is a domain-name set */
	    $output .= '<h3>'.$LANG->getLL('domain_name').'</h3>';
	    
	    $domain = tx_tcdirectmail_tools::getDomainForPage($_REQUEST['id']);
	    if ($domain) {
		$output .= '<p><img src="'.$ICON_PATH.'icon_ok.gif" />'.str_replace ('###DOMAIN###', $domain, $LANG->getLL('domain_ok')).'</p>';
	    } else {
		$output .= '<p><img src="'.$ICON_PATH.'icon_fatalerror.gif" />'.$LANG->getLL('domain_notok').'</p>';
	    }



	    /* Get starttime for lock-records */
	    $rs = $TYPO3_DB->exec_SELECTquery('begintime', 
					    'tx_tcdirectmail_lock', 
					    "stoptime = 0 AND pid = $_REQUEST[id]");
	    list ($begintime) = $TYPO3_DB->sql_fetch_row($rs);


	    $output .= '<form>';
	    
	    
	    /* Real sends? */
	    $output .= '<h3>'.$LANG->getLL('status_real_receivers').'</h3>';
	    if ($targetUids) {
		$targetUids = explode(',',$targetUids);
		foreach ($targetUids as $targetUid) {
		    $target = tx_tcdirectmail_target::loadTarget($targetUid);
		    $total_to_send += $target->getCount();
		}
	    
		if ($begintime) {		
		    $rs = $TYPO3_DB->exec_SELECTquery('COUNT(uid)',
						'tx_tcdirectmail_sentlog',
						"begintime = '$begintime' AND pid = $_REQUEST[id]");
						
						
		
    		    list ($already_sent) = $TYPO3_DB->sql_fetch_row($rs);

		    
		    $output .= '<p>'.str_replace('###STATUS###',"$already_send / $total_to_send",$LANG->getLL('currently_sending')).'</p>';
		} elseif ($sendtime != 0) {
		    $output .= '<p>'.str_replace('###TIME_TO_SEND###', strftime('%Y-%m-%d %H:%M', $sendtime),
					str_replace('###NUMBERS_TO_SEND###', $total_to_send,
					    $LANG->getLL('scheduled_info'))) .'</p>';
		} else {
		    $output .= '<p>'.$LANG->getLL('not_scheduled').'</p>';
		    $output .= '<p>'.$LANG->getLL('total_receivers').' : '.$total_to_send.'</p>';
		    $output .= '<p><input type="submit" name="send_now" value="'.$LANG->getLL('send_now').'" /></p>';
		}
	    } else {
		$output .= '<p><strong>'.$LANG->getLL('no_real_receivers').'</strong></p>';
	    }
		
	    /* Test sends? */
	    $output .= '<h3>'.$LANG->getLL('status_test_receivers').'</h3>';
	    if ($testUid) {
		$target = tx_tcdirectmail_target::loadTarget($testUid);
	    
		if ($_REQUEST['send_test']) {
		    $output .= '<p>'.$LANG->getLL('testmail_sent').'</p>';
		} else {
		    $output .= '<p>'.$LANG->getLL('not_currently_sending').'</p>';
		}
		
		$output .= '<table>';
		
		/* List what users can be mailed */
		while ($record = $target->getRecord()) {
		    if (!$tbl_headers_set) {
			$output .= '<tr><td></td><td><strong>';
			$output .= implode('</strong></td><td><strong>', array_keys($record));
			$output .= '</strong></td></tr>';
			$tbl_headers_set = true;
		    }
		
		    $output .= '<tr><td>';
		    $output .= '<input type="checkbox" name="test_send_receivers[]" value="'.$record['email'].'" ';
		    if (@in_array($record['email'], $_REQUEST['test_send_receivers'])) {
			$output .= 'checked ';
		    }
		    $output .= '/></td><td>';
		    
		    
		    $output .= implode ('</td><td>', $record);
		    $output .= '</td></tr>';
		}
		$output .= '</table>';
		
		$output .= '<p>';
		$output .= '<input type="submit" name="send_test" value="'.$LANG->getLL('send_test').'" />';
		$output .= '</p>';	
	    } else {	
		$output .= '<p><strong>'.$LANG->getLL('no_test_receivers').'</strong></p>';
	    }
	    
	    $output .= '</form>';
	    
	    return $output;
	}
	
	function checkMailValidity() {
	    global $LANG;
	    global $ICON_PATH;
	
	    $warn = array();
	    $fail = array();
	    $note = array();
	
	    /* Get the page-contents */
	    $id = $_REQUEST['id'];
	    $domain = tx_tcdirectmail_tools::getDomainForPage($id);
	    $html_src = file_get_contents("http://$domain/index.php?id=$id&no_cache=1");
	    

	    /* Any linked CSS-files */
	    if (strpos($html_src, '<link rel="stylesheet" type="text/css" href="')) {
		$note[] = $LANG->getLL('mail_contains_linked_styles');
	    }

    	    /* Find linked css and convert into a style-tag */
	    preg_match_all('|<link rel="stylesheet" type="text/css" href="(.*)" />|Ui', $html_src, $urls);
	    foreach ($urls[1] as $i => $url) {
	        $get_url = str_replace("http://$domain/", '', $url);
	        $html_src = str_replace ($urls[0][$i],
	                "<style type=\"text/css\">\n<!--\n"
	                .file_get_contents(PATH_site.str_replace("http://$domain/", '', $url))
	                ."\n-->\n</style>", $html_src);
	    }
																
	    /* Any javascript */
	    if (strpos($html_src, '<script')) {
		$fail[] = $LANG->getLL('mail_contains_javascript');
	    }
	    
	    
	    /* Images in CSS */
	    if (preg_match('|background-image: url\([^\)]+\)|', $html_src) || preg_match('|list-style-image: url\([^\)]+\)|', $html_src)) {
		$fail[] = $LANG->getLL('mail_contains_css_images');
	    }
	    
	    /* CSS-classes */
	    if (preg_match('|<[a-z]+ [^>]*class="[^"]+"[^>]*>|', $html_src)) {
		$note[] = $LANG->getLL('mail_contains_css_classes');
	    }
	    
	    /* Positioning & element sizes in CSS */
	    if (preg_match_all('|<[a-z]+[^>]+style="([^"]*)"|', $html_src, $matches)) {
	    
		foreach ($matches[1] as $stylepart) {
		    if (strpos($stylepart, 'width') !== false) {
			$warn[] = str_replace ('###PROPERTY###','width', $LANG->getLL('mail_contains_css_some_property'));
		    }
		
		    if (strpos($stylepart, 'margin') !== false) {
			$warn[] = str_replace ('###PROPERTY###','margin', $LANG->getLL('mail_contains_css_some_property'));
		    }

		    if (strpos($stylepart, 'height') !== false) {
			$warn[] = str_replace ('###PROPERTY###','height', $LANG->getLL('mail_contains_css_some_property'));
		    }

		    if (strpos($stylepart, 'padding') !== false) {
			$warn[] = str_replace ('###PROPERTY###','padding', $LANG->getLL('mail_contains_css_some_property'));
		    }

		    if (strpos($stylepart, 'position') !== false) {
			$warn[] = str_replace ('###PROPERTY###','position', $LANG->getLL('mail_contains_css_some_property'));
		    }
		}
		
		$warn = array_unique($warn);
	    }
	    
	    if (count($fail)) {
		$content .= '<h4>'.$LANG->getLL('mail_contains_serious_errors').'</h4>';
		foreach ($fail as $failure) {
		    $content .= '<p><img src="'.$ICON_PATH.'icon_fatalerror.gif" />'.$failure.'</p>';
		}
	    } else {
		$content .= '<h4><img src="'.$ICON_PATH.'icon_ok.gif" />'.$LANG->getLL('mail_contains_no_serious_errors').'</h4>';
	    }
	    
	    if (count($warn)) {
		$content .= '<h4>'.$LANG->getLL('mail_contains_warnings').'</h4>';
		foreach ($warn as $warning) {
		    $content .= '<p><img src="'.$ICON_PATH.'icon_warning.gif" />'.$warning.'</p>';
		}
	    } else {
		$content .= '<h4><img src="'.$ICON_PATH.'icon_ok.gif" />'.$LANG->getLL('mail_contains_no_warnings').'</h4>';
	    }
	    
	    if (count($note)) {
		$content .= '<h4>'.$LANG->getLL('mail_contains_notices').'</h4>';
		foreach ($note as $notice) {
		    $content .= '<p><img src="'.$ICON_PATH.'icon_note.gif" />'.$notice.'</p>';
		}
	    } else {
		$content .= '<h4><img src="'.$ICON_PATH.'icon_ok.gif" />'.$LANG->getLL('mail_contains_no_notices').'</h4>';
	    }
	    
	    
	    return $content;
	}

	
	
	function notADirectmailPage() {
	    return '<p>'.$GLOBALS['LANG']->getLL('not_a_directmail').'</p>';
	}
	
	function doMaintenance () {
	    global $LANG;
	    global $TYPO3_DB;
	
	    /* Clear invalid stats? */
	    if ($_REQUEST['clear_invalid']) {
		$sql = "DELETE FROM tx_tcdirectmail_sentlog WHERE begintime = 0 AND pid = $_REQUEST[id]";
		$TYPO3_DB->sql_query($sql);
		$sql = "DELETE FROM tx_tcdirectmail_lock WHERE (begintime = 0 OR stoptime = 0) AND pid = $_REQUEST[id]";
		$TYPO3_DB->sql_query($sql);
	    }
	    
	    if ($_REQUEST['delete_begintime']) {
		$sql = "DELETE tx_tcdirectmail_lock, tx_tcdirectmail_sentlog, tx_tcdirectmail_clicklinks FROM tx_tcdirectmail_lock
			LEFT JOIN tx_tcdirectmail_sentlog ON tx_tcdirectmail_lock.begintime = tx_tcdirectmail_sentlog.begintime
			LEFT JOIN tx_tcdirectmail_clicklinks ON tx_tcdirectmail_sentlog.uid = tx_tcdirectmail_clicklinks.sentlog
			WHERE tx_tcdirectmail_lock.pid = $_REQUEST[id]
			AND tx_tcdirectmail_lock.begintime = $_REQUEST[delete_begintime]";
		$TYPO3_DB->sql_query($sql);			
	    }
	
	
	    /* Invalid-stats form */
	    $out .= "<form action=\"index.php?id=$_REQUEST[id]\">";
	    $sql = "SELECT uid FROM tx_tcdirectmail_sentlog WHERE begintime = 0 AND pid = $_REQUEST[id] LIMIT 1";

	    $rs = $TYPO3_DB->sql_query($sql);
	    $invalid_log = $TYPO3_DB->sql_fetch_row($rs);
	    
	    $sql = "SELECT uid FROM tx_tcdirectmail_lock WHERE (begintime = 0 OR stoptime = 0) AND pid = $_REQUEST[id] LIMIT 1";
	    $rs = $TYPO3_DB->sql_query($sql);
	    $invalid_lock = $TYPO3_DB->sql_fetch_row($rs);
	    
	    $out .= '<p><h3>'.$LANG->getLL('stats_status').'</h3></p>';
	    if ($invalid_lock || $invalid_log) {
		$out .= '<p>'.$LANG->getLL('invalid_stats_found').'</p>';
		$out .= '<p><input type="submit" name="clear_invalid" value="'.$LANG->getLL('clear_invalid').'" /></p>';
	    } else {
		$out .= '<p>'.$LANG->getLL('stats_ok').'</p>';
	    }
	    
	    
	    /* Old-stats form */
	    /* Get numbers for each session */
	    $sql = "SELECT lck.begintime, lck.stoptime, COUNT(lg.receiver)
		    FROM tx_tcdirectmail_lock lck
		    LEFT JOIN tx_tcdirectmail_sentlog lg ON lck.begintime = lg.begintime
		    WHERE lck.pid = $_REQUEST[id]
		    AND lg.pid = $_REQUEST[id]
		    GROUP BY 1,2";
					    
	    $rs = $TYPO3_DB->sql_query($sql);



	    /* Display */
	    $out .= '<p><h3>'.$LANG->getLL('delete_old_stats').'</h3></p>';
	    $out .= '<table>';
	    $out .= '<tr><td></td><td>'.
			    $LANG->getLL('date').'</td><td>'.
			    $LANG->getLL('fromtime').'</td><td>'.
			    $LANG->getLL('totime').'</td><td>'.
			    $LANG->getLL('total_receivers').'</td></tr>';
					    
	    while (list($begintime, $stoptime, $num_receivers) = $TYPO3_DB->sql_fetch_row($rs)) {
		$out .= "<tr style=\"background-color: eeeeee;\">
				    <td><a href=\"index.php?id=$_REQUEST[id]&delete_begintime=$begintime\"><strong>".
				    $LANG->getLL('delete')."</strong></td><td>".
				    strftime('%Y-%m-%d',$begintime)."</td>
				    <td>".strftime('%H:%M',$begintime).'</td><td>'.strftime('%H:%M',$stoptime)."</td>
				    <td align=right>".$num_receivers."</td></tr>";
	    }
	    $out .= '</table>';
	    $out .= '</form>';
	    
	    return $out;
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tcdirectmail/mod1/index.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tcdirectmail/mod1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_tcdirectmail_module1");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>