<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2006 Daniel Schledermann (daniel@typoconsult.dk)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module 'Directmail' for the 'tcdirectmail' extension.
 *
 * @author	Daniel Schledermann <daniel@typoconsult.dk>
 */





	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);	
require_once ('../class.tx_tcdirectmail_tools.php');
require_once ("conf.php");

require_once ($BACK_PATH."init.php");
require_once ($BACK_PATH."template.php");
require_once (PATH_typo3conf.'/localconf.php');
$LANG->includeLLFile("EXT:tcdirectmail/mod2/locallang.php");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

$ICON_PATH = $BACK_PATH.'gfx/';


class tx_tcdirectmail_module2 extends t3lib_SCbase {
	var $pageinfo;

	/**
	 * 
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		
		parent::init();

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
		$TYPO3_DB = $GLOBALS['TYPO3_DB'];
		
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 */
	function menuConfig()	{
		global $LANG;
		$this->MOD_MENU = Array (
			"function" => Array (
				"1" => $LANG->getLL("sys_status"),			
			)
		);
		parent::menuConfig();
	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;

		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{
	
				// Draw the header.
			$this->doc = t3lib_div::makeInstance("bigDoc");
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form='<form action="" method="POST">';

				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				</script>
			';

			$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
			$this->content.=$this->doc->divider(5);

			
			// Render content:
			$this->moduleContent();

			
			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
			}
		
			$this->content.=$this->doc->spacer(10);
		} else {
				// If no access or if ID == zero
		
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
		
			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	}

	/**
	 * Prints out the module HTML
	 */
	function printContent()	{

		$this->content.=$this->doc->endPage();
		echo $this->content;
	}
	
	/**
	 * Generates the module content
	 */
	function moduleContent()	{
		global $LANG;
		
		switch((string)$this->MOD_SETTINGS["function"])	{

			case 1:
				$content = $this->viewSysStatus();
				$this->content.=$this->doc->section($LANG->getLL("sys_status"),$content,0,1);
			break;
			
		} 
	}
	
	
	function viewSysStatus () {
	    global $LANG;
	    global $TYPO3_DB;
	    global $TYPO3_CONF_VARS;
	    global $ICON_PATH;

	    /* Check if we're in safemode. If we are, these checks are better done manually */
	    if( ini_get('safe_mode') ){
		return $LANG->getLL('system_status_safemode');
	    }
	
	    /* Check if the mailer.php is executable */
	    $content .= '<h3>'.$LANG->getLL('mailer_php').'</h3>';	    
	    $mailer_php = dirname(dirname(__FILE__)).'/mailer.php';
	    $mailer_lines = file($mailer_php);
	    $current_php = trim(str_replace('#!', '', $mailer_lines[0]));
	    $new_php = trim($TYPO3_CONF_VARS['EXTCONF']['tcdirectmail']['pathToPHP']);
	    
	    if ($_REQUEST['try_correct_path']) {
		/* Correct the sh-bang */
		$mailer_lines[0] = "#!$new_php\n";
		$fd = fopen($mailer_php, 'w');
		fwrite($fd, implode("", $mailer_lines));
		fclose ($fd);
		
		/* Reload file */
		$mailer_lines = file($mailer_php);
		$current_php = trim(str_replace('#!', '', $mailer_lines[0]));
	    }


	    if ($_REQUEST['try_make_exe']) {
		
		/* Set exe-bit */
		list(,,$mode) = stat($mailer_php);
		$mode |= 0110;
		chmod($mailer_php, $mode);
		clearstatcache();
	    }	    

	    exec("$mailer_php --test", $dummy, $return_status);

	    if (!$return_status && $new_php == $current_php) {
		$content .= '<p><img src="'.$ICON_PATH.'icon_ok.gif" />'.$LANG->getLL('mailer_exe_ok').'</p>';
		$content .= '<p>'.str_replace('###MAILERPATH###', $mailer_php, $LANG->getLL('crontab_explain')).'</p>';
		
	    } else {
		$content .= '<form>';
		$content .= '<input type="hidden" name="id" value="'.$_REQUEST['id'].'" />';
	    

		if ($new_php != $current_php) {
		    $content .= '<p><img src="'.$ICON_PATH.'icon_fatalerror.gif" />'.
									    str_replace('###CONFIGURED_PHP###', $new_php,
										str_replace('###CURRENT_PHP###', $current_php,
										$LANG->getLL('php_wrong_path'))).'</p>';		
		    $content .= '<p><input type="submit" name="try_correct_path" value="'.$LANG->getLL('try_correct_path').'" /></p>';
		} else {
		    $content .= '<p><img src="'.$ICON_PATH.'icon_fatalerror.gif" />'.$LANG->getLL('mailer_exe_notok').'</p>';		
		    if (!is_executable($current_php)) {
			$content .= '<p>'.$LANG->getLL('php_not_executable').'</p>';
		    } else {
			$content .= '<p><input type="submit" name="try_make_exe" value="'.$LANG->getLL('try_make_exe').'" /></p>';
		    }
		}

		$content .= '</form>';
	    }
	    
	    
	    
	    
	    
	    /* Check if we have a Lynx-executable */
	    $content .= '<h3>'.$LANG->getLL('lynx_browser').'</h3>';
	    
	    exec ($TYPO3_CONF_VARS['EXTCONF']['tcdirectmail']['pathToLynx'].' -version', $lynxoutput);
	    list ($lynxversion) = $lynxoutput;
	    
	    if (preg_match ('|^Lynx|', $lynxversion)) {
		$content .= '<p><img src="'.$ICON_PATH.'icon_ok.gif" />'.str_replace('###LYNX_VERSION###', $lynxversion, $LANG->getLL('lynx_found')).'</p>';
	    } else {
		$content .= '<p><img src="'.$ICON_PATH.'icon_warning.gif" />'.
						str_replace('###LYNX_PATH###', $TYPO3_CONF_VARS['tcdirectmail']['pathToLynx'],
					    $LANG->getLL('lynx_not_found')).'</p>';
	    } 
	    
	    
	    return $content;
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tcdirectmail/mod2/index.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/tcdirectmail/mod2/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_tcdirectmail_module2");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>